/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


/*****************************************************************************
*
*  MODULE :             conversion module
*  SCOPE :              Basic types conversion for heterogeneity
*  FILE :               conversion.hxx
*  AUTHORS :            E. Abecassis
*  CREATION DATE :      February 1, 1994
*  COPYRIGHTS :        (C) Apic Systemes, 1994
*  HISTORY :
*
******************************************************************************/

/* IMPORTS *******************************************************************/

#ifndef __conversion_HXX
#define __conversion_HXX

/* little-indian ieee float Version */

#ifdef __alpha

#include <machine/endian.h>

#define LOW 1
#define HIGH 0

inline double ntohd(double in) 
{
  register long out[2] ;
  
  out[LOW] = ntohl(((int*)&in)[0]) ;
  out[HIGH] = ntohl(((int*)&in)[1]) ;
  return *(double*)out ;
}


inline double htond(double in)
{
  register long out[2] ;
  
  out[LOW] = htonl(((int*)&in)[0]) ;
  out[HIGH] = htonl(((int*)&in)[1]) ;
  return *(double*)out ;
}


inline float htonf(float in)
{
  register long out ;

  out = htonl(*(int*)&in) ;
  return *(float*)&out ;
}


inline float ntohf(float in)
{
  register long out ;

  out = ntohl(*(int*)&in) ;
  return *(float*)&out ;
}

#else
/* big-indian ieee float Version */


#define ntohd(x) x
#define htond(x) x
#define ntohf(x) x
#define htonf(x) x

#endif

#endif
